
#ifndef CPUIO_H
#define CPUIO_H

#include "cpu.h"

#define DEFAULT_BAUD_RATE 38400

#define MONARGV0 "umon"


#define IORD_UART_RXDATA(base)          IORD( base, 0);
#define IOWR_UART_RXDATA(base, data)    IOWR( base, 0, data)

#define IORD_UART_TXDATA(base)          IORD( base, 1)
#define IOWR_UART_TXDATA(base, data)    IOWR( base, 1, data)

#define IORD_UART_STATUS(base)          IORD( base, 2)
#define IOWR_UART_STATUS(base, data)    IOWR( base, 2, data)

#define UART_STATUS_PE_MSK              (0x1)
#define UART_STATUS_PE_OFST             (0)
#define UART_STATUS_FE_MSK              (0x2)
#define UART_STATUS_FE_OFST             (1)
#define UART_STATUS_BRK_MSK             (0x4)
#define UART_STATUS_BRK_OFST            (2)
#define UART_STATUS_ROE_MSK             (0x8)
#define UART_STATUS_ROE_OFST            (3)
#define UART_STATUS_TOE_MSK             (0x10)
#define UART_STATUS_TOE_OFST            (4)
#define UART_STATUS_TMT_MSK             (0x20)
#define UART_STATUS_TMT_OFST            (5)
#define UART_STATUS_TRDY_MSK            (0x40)
#define UART_STATUS_TRDY_OFST           (6)
#define UART_STATUS_RRDY_MSK            (0x80)
#define UART_STATUS_RRDY_OFST           (7)
#define UART_STATUS_E_MSK               (0x100)
#define UART_STATUS_E_OFST              (8)
#define UART_STATUS_DCTS_MSK            (0x400)
#define UART_STATUS_DCTS_OFST           (10)
#define UART_STATUS_CTS_MSK             (0x800)
#define UART_STATUS_CTS_OFST            (11)
#define UART_STATUS_EOP_MSK             (0x1000)
#define UART_STATUS_EOP_OFST            (12)

#define IORD_UART_CONTROL(base)         IORD( base, 3)
#define IOWR_UART_CONTROL(base, data)   IOWR( base, 3, data)

#define UART_CONTROL_PE_MSK             (0x1)
#define UART_CONTROL_PE_OFST            (0)
#define UART_CONTROL_FE_MSK             (0x2)
#define UART_CONTROL_FE_OFST            (1)
#define UART_CONTROL_BRK_MSK            (0x4)
#define UART_CONTROL_BRK_OFST           (2)
#define UART_CONTROL_ROE_MSK            (0x8)
#define UART_CONTROL_ROE_OFST           (3)
#define UART_CONTROL_TOE_MSK            (0x10)
#define UART_CONTROL_TOE_OFST           (4)
#define UART_CONTROL_TMT_MSK            (0x20)
#define UART_CONTROL_TMT_OFST           (5)
#define UART_CONTROL_TRDY_MSK           (0x40)
#define UART_CONTROL_TRDY_OFST          (6)
#define UART_CONTROL_RRDY_MSK           (0x80)
#define UART_CONTROL_RRDY_OFST          (7)
#define UART_CONTROL_E_MSK              (0x100)
#define UART_CONTROL_E_OFST             (8)
#define UART_CONTROL_DCTS_MSK           (0x400)
#define UART_CONTROL_DCTS_OFST          (10)
#define UART_CONTROL_RTS_MSK            (0x800)
#define UART_CONTROL_RTS_OFST           (11)
#define UART_CONTROL_EOP_MSK            (0x1000)
#define UART_CONTROL_EOP_OFST           (12)

#define IORD_UART_DIVISOR(base)         IORD( base, 4)
#define IOWR_UART_DIVISOR(base, data)   IOWR( base, 4, data)

#define IORD_UART_EOP(base)             IORD( base, 5)
#define IOWR_UART_EOP(base, data)       IOWR( base, 5, data)

#define UART_EOP_MSK                    (0xFF)
#define UART_EOP_OFST                   (0)

#endif /* __ALTERA_AVALON_UART_REGS_H__ */
