#ifndef _SD_LLD_H
#define _SD_LLD_H

#include <cyg/hal/io.h>
#include <cyg/infra/cyg_type.h>

typedef struct _SD_CMD
{
	unsigned char 		Cmd;
	unsigned int  		Arg;
	unsigned char 		Crc;
	unsigned char *	pResp;
	unsigned int      RespLength;
	unsigned char *	pData;
	unsigned int      DataLength;
	unsigned short    BlkCrc;
   unsigned int      Flags;

} SD_CMD, * PSD_CMD;

// all of the card configuration data OCR, CID, CSD
typedef struct _SD_CONF
{
	unsigned char sdOcr[ 5];
	unsigned char sdCid[16];
	unsigned char sdCsd[16];

} SD_CONF, * PSD_CONF;

// flag definitions
#define SD_80_CLK_INIT ( 1 << 0) // send 80 clocks prior to command at init
#define SD_BLK_READ    ( 1 << 1)
#define SD_BLK_WRITE   ( 1 << 2)

#define IOADDR_ALTERA_AVALON_SPI_RXDATA(base)         __IO_CALC_ADDRESS_NATIVE(base, 0)
#define IORD_ALTERA_AVALON_SPI_RXDATA(base)           IORD(base, 0)
#define IOWR_ALTERA_AVALON_SPI_RXDATA(base, data)     IOWR(base, 0, data)

#define IOADDR_ALTERA_AVALON_SPI_TXDATA(base)         __IO_CALC_ADDRESS_NATIVE(base, 1)
#define IORD_ALTERA_AVALON_SPI_TXDATA(base)           IORD(base, 1)
#define IOWR_ALTERA_AVALON_SPI_TXDATA(base, data)     IOWR(base, 1, data)

#define IOADDR_ALTERA_AVALON_SPI_STATUS(base)         __IO_CALC_ADDRESS_NATIVE(base, 2)
#define IORD_ALTERA_AVALON_SPI_STATUS(base)           IORD(base, 2)
#define IOWR_ALTERA_AVALON_SPI_STATUS(base, data)     IOWR(base, 2, data)

#define ALTERA_AVALON_SPI_STATUS_ROE_MSK              (0x8)
#define ALTERA_AVALON_SPI_STATUS_ROE_OFST             (3)
#define ALTERA_AVALON_SPI_STATUS_TOE_MSK              (0x10)
#define ALTERA_AVALON_SPI_STATUS_TOE_OFST             (4)
#define ALTERA_AVALON_SPI_STATUS_TMT_MSK              (0x20)
#define ALTERA_AVALON_SPI_STATUS_TMT_OFST             (5)
#define ALTERA_AVALON_SPI_STATUS_TRDY_MSK             (0x40)
#define ALTERA_AVALON_SPI_STATUS_TRDY_OFST            (6)
#define ALTERA_AVALON_SPI_STATUS_RRDY_MSK             (0x80)
#define ALTERA_AVALON_SPI_STATUS_RRDY_OFST            (7)
#define ALTERA_AVALON_SPI_STATUS_E_MSK                (0x100)
#define ALTERA_AVALON_SPI_STATUS_E_OFST               (8)

#define IOADDR_ALTERA_AVALON_SPI_CONTROL(base)        __IO_CALC_ADDRESS_NATIVE(base, 3)
#define IORD_ALTERA_AVALON_SPI_CONTROL(base)          IORD(base, 3)
#define IOWR_ALTERA_AVALON_SPI_CONTROL(base, data)    IOWR(base, 3, data)

#define ALTERA_AVALON_SPI_CONTROL_IROE_MSK            (0x8)
#define ALTERA_AVALON_SPI_CONTROL_IROE_OFST           (3)
#define ALTERA_AVALON_SPI_CONTROL_ITOE_MSK            (0x10)
#define ALTERA_AVALON_SPI_CONTROL_ITOE_OFST           (4)
#define ALTERA_AVALON_SPI_CONTROL_ITRDY_MSK           (0x40)
#define ALTERA_AVALON_SPI_CONTROL_ITRDY_OFS           (6)
#define ALTERA_AVALON_SPI_CONTROL_IRRDY_MSK           (0x80)
#define ALTERA_AVALON_SPI_CONTROL_IRRDY_OFS           (7)
#define ALTERA_AVALON_SPI_CONTROL_IE_MSK              (0x100)
#define ALTERA_AVALON_SPI_CONTROL_IE_OFST             (8)
#define ALTERA_AVALON_SPI_CONTROL_SSO_MSK             (0x400)
#define ALTERA_AVALON_SPI_CONTROL_SSO_OFST            (10)

#define IOADDR_ALTERA_AVALON_SPI_SLAVE_SEL(base)      __IO_CALC_ADDRESS_NATIVE(base, 5)
#define IORD_ALTERA_AVALON_SPI_SLAVE_SEL(base)        IORD(base, 5)
#define IOWR_ALTERA_AVALON_SPI_SLAVE_SEL(base, data)  IOWR(base, 5, data)




#define SD_GO_IDLE_STATE  		 0
#define SD_SEND_CSD  		    9
#define SD_SEND_CID   		   10
#define SD_STOP_TRANSMISSION  12
#define SD_SET_BLOCKLEN			16
#define SD_READ_SINGLE_BLOCK	17
#define SD_WRITE_SINGLE_BLOCK	24
#define SD_SEND_OP_COND  		41
#define SD_APP_CMD       		55
#define SD_READ_OCR           58


#endif // SD_LLD_H
