/* tfsdev.h:
    This file is ONLY included by tfs.c.  It is seperate from tfs.h because
    it is target-specific.  It is not part of config.h because it includes
    the declaration of the tfsdevtbl[].
    A prefix in the name of the file determines what device is used to store
    that file.  If no prefix is found the the first device in the table is
    used as a default.  The syntax of the prefix is "//STRING/" where STRING
    is user-definable, but the initial // and final / are required by tfs
    code.
*/

struct tfsdev tfsdevtbl[] = {
#ifdef USE_TWO_TFS_DEVICES
    {   "//A/",
        TFSSTART_A,
        TFSEND_A,
        TFSSPARE_A,
        TFSSPARESIZE_A,
        TFSSECTORCOUNT_A,
        TFS_DEVTYPE_FLASH, },
    {   "//B/",
#else
    {   "//FLASH/",
#endif
        TFSSTART_B,
        TFSEND_B,
        TFSSPARE_B,
        TFSSPARESIZE_B,
        TFSSECTORCOUNT_B,
        TFS_DEVTYPE_FLASH, },
#ifdef FLASHRAM_BASE
    {   "//RAM/",
        FLASHRAM_BASE,
        FLASHRAM_END-FLASHRAM_SECTORSIZE,
        FLASHRAM_END-FLASHRAM_SECTORSIZE+1,
        FLASHRAM_SECTORSIZE,
        FLASHRAM_SECTORCOUNT-1,
        TFS_DEVTYPE_RAM | TFS_DEVINFO_AUTOINIT, },
#endif
    { 0, TFSEOT,0,0,0,0,0 }
};
