/* ffx.c
 *
 * By David de la Cruz.
 *
 * Modified by Technology Rescue.
 *	12.03.2003 : CSB226 adaptation.
 *	20.08.2003 : added INCLUDE_FLASHFX.
 */

#include "config.h"
#include "cpuio.h"
#include "flash.h"

#if INCLUDE_FLASHFX

volatile unsigned long jiffies;	// for compatibility with testoem.c file.

char *ffx_initHelp[] = {
	" This command initialise FFX disk",
	"",
	"",
	"",
	0
};
/**************************************************************************
 *
 * int ffx_init(void)
 *   Input parameters:
 *	none.
 *
 *   Output:
 *	TRUE - if a FFX was correctly initialised.
 *	FALSE - if there's no FFX capabilities.
 *
 *   Description:
 *	This function updates the flash and boot from RAM.
 *
 **************************************************************************
*/
int ffx_init(void)
{
	int bSuccess = 0;	// used to report if init is successfull or failed. Assume failure.
//	unsigned long int ulMediaSize =	FLASH_BOOT_SIZE;
//	unsigned long int ulMediaSize =	0x00800000 * 3;
	unsigned long int ulMediaSize = (1 << ((FlashBank[0].id) & 0xFF)) * FLASHBANKS;
	unsigned long int ulReservedSize = 0xC0000L;
	unsigned long int ulSpareUnits = 0x2L;
	short numDrives;

	printf("SEFS init... ");
	if(sefinit() == 0)	// SEFS_SUCCESS.
	{	printf("ok.\n");
		bSuccess = 1;
	}
	else
	{
		printf("failed.\n");

		printf("OEM init... ");
		if ( !oeminit(0, &numDrives) )
		{	printf("failed.\n");
		}
		else
		{
			printf("ok.\n");
			/* Ensure drive 0. */
			oemsetcurrentdrive(0);
			vbfsetcurrentdrive(0);
			oemmount();
			printf("VBF fmt... ");

			if(vbfformat(0x12345678, 4, &ulMediaSize, &ulReservedSize, &ulSpareUnits))
			{	printf("\n");
				printf("Mount VBF... ");
				if(vbfmount())
				{
					printf("OK.\nFAT fmt... ");
					if(fatformat(vbfclientsize(), 1, 256, 0x12345678, "FFXDisk"))
					{	printf("ok.\n");
						/* Now, retry to init SEFS interface. */
						if(sefinit() == 0)	// SEFS_SUCCESS.
						{	printf("SEFS ok.\n");
							bSuccess = 1;
						}
					}
				}
				else	
				{
					printf("failed.\n");
				}
			}
			else
			{	printf("failed.\n");
			}
		}
	}
	return bSuccess;
}

#endif	/* INCLUDE_FLASHFX */
