#ifndef ASSEMBLY_ONLY
#include "csb737_gpio.h"
#endif
#include "bits.h"

#include "at91sam9263.h"

// board specific defines for micro monitor
#define DEFAULT_BAUD_RATE   	38400
#define MON_CPU_CLOCK       	198656000

#define LOOPS_PER_USEC			3

#define MCK						MON_CPU_CLOCK/2

#define SDRAM_BASE				0x20000000
#define SRAM_BASE				0x00300000

//Big Endian
//#define H2SED(_x_)				(((((ushort)_x_) & 0xff00) >> 8) | ((((ushort)_x_) & 0x00ff) << 8))

//Little Endian
#define H2SED(_x_)				(_x_)

#define CORE_AT_FULL_SPEED 1

#define USE_FONT8X8

//--------------------------------------------------------------------------
// The LCD frame buffer for Umon is fixed at 0x20100000 SDRAM.
//
//#define LCD_FDR_ADD				0x20100000
//#define LCD_FDR(_x_)			*(vulong *)(LCD_FDR_ADD + _x_)	// Frame Descriptor, Frame Buffer
//
//#define LCD_PAL_ADD				0x20100080
//#define LCD_PAL(_x_)			*(vushort *)(LCD_PAL_ADD + _x_)	// Palette Buffer
//
//#define LCD_PDR_ADD				0x20100060
//#define LCD_PDR(_x_)			*(vulong *)(LCD_PDR_ADD + _x_)	// Palette Descriptor, Palette Buffer
//
//#define LCD_BUF_ADD				0x20100280
//#define LCD_BUF(_x_)			*(vushort *)(LCD_BUF_ADD + _x_)	// Frame Buffer

//--------------------------------------------------------------------------
// The LCD frame buffer for Umon is fixed at 0x70000000 PSRAM.
//
#define LCD_FDR_ADD				0x70000000
#define LCD_FDR(_x_)			*(vulong *)(LCD_FDR_ADD + _x_)	// Frame Descriptor, Frame Buffer

#define LCD_PAL_ADD				0x70000080
#define LCD_PAL(_x_)			*(vushort *)(LCD_PAL_ADD + _x_)	// Palette Buffer

#define LCD_PDR_ADD				0x70000060
#define LCD_PDR(_x_)			*(vulong *)(LCD_PDR_ADD + _x_)	// Palette Descriptor, Palette Buffer

#define LCD_BUF_ADD				0x70000280
#define LCD_BUF(_x_)			*(vushort *)(LCD_BUF_ADD + _x_)	// Frame Buffer

#define LCD_GET_PIXEL_ADD(_X_, _Y_)	(((_Y_ * PIXELS_PER_ROW) + _X_)*2)

#include "osd043tn14.h"

// 	Draw defines
#define TOP						0
#define BOTTOM					(PIXELS_PER_COL-1)
#define LEFT					0
#define RIGHT					(PIXELS_PER_ROW-1)
#define CENTER_X				(PIXELS_PER_ROW/2)
#define CENTER_Y				(PIXELS_PER_COL/2)

